#pragma once
#include "libs.h"
#include "gui.h"
#include "view.h"

class Body;

class WorldView: public View {
public:
  WorldView(void);
  virtual void Update(void);
  virtual void Draw3D(void);
  static const float PICK_OBJECT_RECT_SIZE;
  void UpdateCommsOptions(void);
  bool GetShowLabels(void) { return labelsOn; }
private:
  Gui::Button* AddCommsOption(const std::string msg, int ypos);
  void OnClickHyperspace(void);
  void OnClickBlastoff(void);
  void OnChangeWheelsState(Gui::MultiStateImageButton* b);
  void OnChangeLabelsState(Gui::MultiStateImageButton* b);
  virtual bool OnMouseDown(Gui::MouseButtonEvent* e);
  Body* PickBody(const float screenX, const float screenY) const;
  Gui::ImageButton* m_hyperspaceButton;
  GLuint m_bgstarsDlist;
  Gui::Fixed* commsOptions;
  Gui::Label* flightStatus;
  Gui::ImageButton* launchButton;
  bool labelsOn;
};

